freeslot("sfx_frpbnj", "S_FRANK_FLY", "S_FRANK_SKATESWING", "sfx_frsksp", "S_FR_SKATESPIN", "sfx_frwind", "sfx_frtada", "sfx_dinner", "S_FRANK_SBOUNCE", "SPR2_SBNC", "sfx_frdart", "S_FAD_HIDE", "SPR2_FDHI", "sfx_faddie", "sfx_bigjmp", "S_FRANK_FLYTIRE", "sfx_frcoun", "sfx_frtaco", "sfx_frough", "S_FRANK_TIRED", "sfx_frslep", "sfx_frac", "sfx_frspn1", "sfx_frhorn", "sfx_frstmp", "sfx_frlaf1", "sfx_frspok", "sfx_fadwow", "sfx_frfall", "sfx_frpit", "S_FRANK_AIRWALK", "S_FRANK_SLEEP", "S_FRANK_STAKETRICK", "sfx_frbonk", "sfx_frastr", "S_FRANK_BOUNCE", "sfx_frbnce", "S_PLAY_HYPERTRNS_1", "sfx_dsqeak")
states[S_FRANK_BOUNCE] = {SPR_PLAY, SPR2_BNCE, -1, nil, 0, 0, S_FRANK_BOUNCE}
states[S_FRANK_SKATESWING] = {SPR_PLAY, SPR2_TAL1, -1, nil, 0, 0, S_FRANK_SKATESWING}
states[S_FRANK_SBOUNCE] = {SPR_PLAY, SPR2_SBNC|FF_FULLBRIGHT, -1, nil, 0, 0, S_FRANK_SBOUNCE}
states[S_FRANK_SLEEP] = {SPR_PLAY, SPR2_CNT1, 10, nil, 0, 0, S_FRANK_SLEEP}
states[S_FRANK_STAKETRICK] = {SPR_PLAY, SPR2_LAND, 2, nil, 0, 0, S_FRANK_STAKETRICK}
states[S_FRANK_AIRWALK] = {SPR_PLAY, SPR2_PAIN, 1, nil, 0, 0, S_FRANK_AIRWALK}
states[S_FRANK_FLY] = {SPR_PLAY, SPR2_FLY_, 1, nil, 0, 0, S_FRANK_FLY}
states[S_FRANK_FLYTIRE] = {SPR_PLAY, SPR2_TIRE, 1, nil, 0, 0, S_FRANK_FLYTIRE}
states[S_FAD_HIDE] = {SPR_PLAY, SPR2_FDHI, 1, nil, 0, 0, S_FAD_HIDE}
states[S_FR_SKATESPIN] = {SPR_PLAY, SPR2_TAL0, 1, nil, 0, 0, S_FR_SKATESPIN}
states[S_FRANK_TIRED] = {SPR_PLAY, SPR2_MLEE|FF_ANIMATE, 80, nil, 19, 4, S_FRANK_SLEEP}
sfxinfo[sfx_frbnce].caption = "Ground Bounce"
sfxinfo[sfx_frastr].caption = "Pain and Suffering"
sfxinfo[sfx_frbonk].caption = "Bonk"
sfxinfo[sfx_frough].caption = "OUGH"
sfxinfo[sfx_frtaco].caption = "Gong"
sfxinfo[sfx_frcoun].caption = "C.S. Punch"
sfxinfo[sfx_dsqeak].caption = "Squeak"
sfxinfo[sfx_frpit].caption = "AAAAAaaaa..."
sfxinfo[sfx_frfall].caption = "AAAAAaaaa..."
sfxinfo[sfx_fadwow].caption = "Wow!"
sfxinfo[sfx_frac].caption = "Equip"
sfxinfo[sfx_frspn1].caption = "SpeEEeEn.."
sfxinfo[sfx_frhorn].caption = "Airhorn"
sfxinfo[sfx_frstmp].caption = "Stamp Earned"
sfxinfo[sfx_frlaf1].caption = "Ha HA!"
sfxinfo[sfx_frspok].caption = "It's the spooky month!"
sfxinfo[sfx_frslep].caption = "Snore"
sfxinfo[sfx_bigjmp].caption = "Big Jump"
sfxinfo[sfx_faddie].caption = "Explosion"
sfxinfo[sfx_frdart].caption = "Dart acquired"
sfxinfo[sfx_dinner].caption = "Dinner."
sfxinfo[sfx_frtada].caption = "Ta Da!"
sfxinfo[sfx_frsksp].caption = "SkateNado Spin"
sfxinfo[sfx_frwind].caption = "/"
sfxinfo[sfx_frpbnj].caption = "Peanut butter jelly time!"

//mini nuke
local explodelol = function(inflictor, source, radius, pl, grounded, spikesplease)
	for mo in mobjs.iterate()
		if not (mo and mo.valid and mo.health)
			continue
		end
		if (pl.powers[pw_super])
			if not (mo.flags & MF_SHOOTABLE) and not (mo.type == MT_EGGGUARD or mo.type == MT_MINUS
			or mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE)
				continue
			end
		end
		if mo.type == MT_PLAYER and not G_RingSlingerGametype()
			continue // Don't hurt players in Co-Op
		end
		if grounded
			if not P_IsObjectOnGround(mo)
				continue
			end
		end
		if abs(inflictor.x - mo.x) > radius or abs(inflictor.y - mo.y) > radius or abs(inflictor.z - mo.z) > radius
			continue 
		end
		if FixedHypot(FixedHypot(inflictor.x - mo.x, inflictor.y - mo.y), inflictor.z - mo.z) > radius
			continue
		end
		if mo.type == MT_MINUS and not (mo.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mo.flags = (mo.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end
		if mo.type == MT_EGGGUARD and mo.tracer 
			P_KillMobj(mo.tracer, inflictor, source, DMG_NUKE)
		end
		if (pl.powers[pw_super])
		or (pl.solchar and pl.solchar.istransformed)
		or spikesplease
			if mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE
				P_KillMobj(mo, inflictor, source, DMG_NUKE) 
			end
		end
		P_DamageMobj(mo, inflictor, source, 1, DMG_NUKE)
	end
end


//particle junk
local jumpdust = function(inflictor, ns, item)
	for i = 1,12
		local fa = (i*ANG30)
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, item)
		mo.scale = inflictor.scale
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa), ns)
			mo.momx = FixedMul(sin(fa), ns)
			mo.momz = -ns*FRACUNIT/3
		end
		mo.destscale = $/5
		mo.scalespeed = FRACUNIT/12
		i = $+1
	end
end

//groundbounce poses
local setpose = function(inflictor, pl)
	local poseme = P_RandomRange(0, 10) //how many frames are in the animation (choose a pose, pose 1 to 10 (+1))
	local alreadyposed = 0
	local funnymeme = 0
	local frooksfault = 0
	
	if alreadyposed == 1 return end
	
	if (pl.powers[pw_super]) or (pl.solchar and pl.solchar.istransformed)
		inflictor.state = S_FRANK_SBOUNCE
		inflictor.sprite2 = SPR2_SBNC
	else
		inflictor.state = S_FRANK_BOUNCE
		inflictor.sprite2 = SPR2_BNCE
	end
	if poseme < 10
		inflictor.frame = poseme //randomly select a frame from the state and use it!
	else
		funnymeme = P_RandomRange(1, 15) //how rare are these gonna be?
		if funnymeme == 1
			inflictor.frame = 10 //fat dart
			S_StartSound(inflictor, sfx_frdart)
		elseif funnymeme == 2
			inflictor.frame = 11 //gun
			S_StartSound(inflictor, sfx_corkp)
		elseif funnymeme == 3 //KILL
			inflictor.frame = 12
			S_StartSound(inflictor, sfx_frlaf1)
		elseif funnymeme == 4
			inflictor.frame = 13 //old pose
			S_StartSound(inflictor, sfx_kc48)
		elseif funnymeme == 5
			inflictor.frame = 14 //Dinner.
			S_StartSound(inflictor, sfx_dinner)
		elseif funnymeme == 6 //the most rarest pose
			frooksfault = P_RandomRange(1, 10)
			if frooksfault == 2
				inflictor.frame = 15 // god fucking damn it frook
				S_StartSound(inflictor, sfx_fadswp)
			else
				inflictor.frame = P_RandomRange(0, 9) //pick one of the 10 basic frames instead
			end
		elseif funnymeme == 7
			inflictor.frame = 16 //A 2019 callback
			S_StartSound(inflictor, sfx_frtada)
		elseif funnymeme == 8 	
		and not pl.fadposestop
			inflictor.frame = 17 -- dummie :)
			S_StartSound(inflictor, sfx_fadswp)
			P_SpawnMobjFromMobj(inflictor, 0,0,0, MT_FADS)
		elseif funnymeme == 8 	
		and pl.fadposestop
			inflictor.frame = P_RandomRange(0, 9)
		else
			inflictor.frame = P_RandomRange(0, 9) //pick one of the 10 basic frames instead
		end
	end
	alreadyposed = 1 //stop spazzing out from all of the poses lol
end

//pain & springtwirls
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.painscream == nil
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.painscream = 0
			player.fixtheroll = 0
			player.painroll = 0
			player.twirl_angle = 1
		end
		if player.mo.state == S_PLAY_PAIN
			player.fixtheroll = 0
		end
		
		if player.trickboostcount == nil
			player.trickboostcount = 0
			player.fadposestop = false
		end
		
		if (player.mo.skin == "frank")
		and player.playerstate == PST_LIVE
			if player.mo.state == S_PLAY_PAIN
				player.sloperollangle_override = true
			else
				player.sloperollangle_override = false
			end
			
			if (P_PlayerInPain(player)) and player.mo.state == S_PLAY_PAIN
				player.painroll = 0
				player.mo.spriteyscale = FRACUNIT
				player.mo.spritexscale = FRACUNIT
				if player.mo.momz > -25*player.mo.scale
					player.mo.rollangle = $ + FixedAngle(-13*FRACUNIT) 
				elseif player.mo.momz <= -25*player.mo.scale
					player.mo.rollangle = $ + FixedAngle(abs(player.mo.momz)*-1) //FASTER
					if player.painscream == 0
						S_StartSound(player.mo, sfx_frfall)
						player.painscream = 1
					end
				end
			elseif player.mo.state == S_PLAY_PAIN and not(P_PlayerInPain(player))
			or P_IsObjectOnGround(player.mo) and  player.mo.state == S_PLAY_PAIN and not(P_PlayerInPain(player)) and player.powers[pw_invulnerability]
			or player.mo.sprite2 == SPR2_PAIN and not P_IsObjectOnGround(player.mo) and player.mo.state != S_PLAY_PAIN
				player.mo.rollangle = $ + FixedAngle(-45*FRACUNIT + (-player.speed/2)) // (water/wind shit)
				player.mo.spriteyscale = FRACUNIT
				player.mo.spritexscale = FRACUNIT
				player.painroll = 1
			end	
			
			if S_SoundPlaying(player.mo, sfx_frfall) and not (P_PlayerInPain(player)) //bro shut up you're good
				S_StopSoundByID(player.mo, sfx_frfall)
			end
			
			//rollangle fixes
			if player.mo.state != S_PLAY_PAIN and P_IsObjectOnGround(player.mo) and player.isxmomentum and player.trickboostcount == 0
				player.mo.rollangle = 0
			end
			if not P_IsObjectOnGround(player.mo) and player.mo.state == S_PLAY_FALL and player.fixtheroll == 0
				player.mo.rollangle = 0
				player.fixtheroll = 1
			end
			if player.mo.state != S_PLAY_PAIN and player.fixtheroll == 0 and player.mo.rollangle != 0
				if player.isxmomentum and player.trickboostcount > 0 return end
				if player.isxmomentum and P_IsObjectOnGround(player.mo) and player.mo.rollangle != 0 return end
				if player.isxmomentum and (player.mo.eflags & MFE_JUSTHITFLOOR) and player.mo.rollangle != 0 return end
				player.mo.rollangle = 0
				player.fixtheroll = 1
			end
			
			//wheee!
			if player.mo.state == S_PLAY_SPRING
				player.twirl_angle = $+ANGLE_22h
				player.drawangle = player.twirl_angle
				player.mo.spriteyscale = FRACUNIT
				player.mo.spritexscale = FRACUNIT
			end
		end
		
		if (player.mo.skin != "frank")
		and player.painroll == 1
		and player.mo.rollangle != 0
			player.mo.rollangle = 0
			player.painroll = 0
		end
		
		if (player.mo.skin == "frank")
		and player.playerstate == PST_DEAD
		and player.mo.state == S_PLAY_PAIN
			player.mo.rollangle = $ + FixedAngle(abs(player.mo.momz)*-2)
		end
	end
end)

//FlightBurst
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "frank")
	and player.playerstate == PST_LIVE 
	
		//measure jumps
		if player.flystep == nil 
			player.flystep = 0 
			player.justbursted = 0
			player.burstcheck = 0
			player.hovrspd = -5
			player.stoproll = 0
			player.justchangedbouncenumber = 0
			player.divesquasher = 0
		end
		
		if (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
		and player.burstcheck == 0 
		or (player.mo.eflags & MFE_JUSTHITFLOOR) 
			player.elefix = 0
			player.flystep = 0 
			player.jumpnumber = 0
			player.startthemeet = 0
			player.flymeets = 204
			player.didafunny = 0
			player.skatefaller = 0
		end
		
		if player.spedmesur == nil
		or not (P_PlayerInPain(player))
			player.spedmesur = player.speed
		end
		
		//to prevent immediate double or triple jump
		if player.usedown == nil 
		or not (player.cmd.buttons & BT_JUMP) 
			player.usedown = 0
			player.justbursted = 0 
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_JUMP) 
			player.usedown = 1 
		end
			
		if player.mo.eflags & MFE_UNDERWATER
			player.hovrspd = -3
		else
			player.hovrspd = -5
		end
		
		if player.spindown == nil 
		or not (player.cmd.buttons & BT_SPIN)
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and player.pflags & PF_SHIELDABILITY and not (player.cmd.buttons & BT_SPIN)
			player.spindown = 0
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_SPIN) 
			player.spindown = 1
		end
		
		
		if player.pflags & PF_JUMPED 
		and player.usedown == 0 
		and not (player.pflags & PF_THOKKED) 
		and player.cmd.buttons & BT_JUMP 
		and player.burstcheck == 0 
		and not (player.exiting) 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
			player.burstcheck = 1 
		end
			
		//jumping time, lets make sure a bunch of stuff aint happenin when we do it first		
		if not (player.pflags & PF_SPINNING) 
		and not (player.pflags & PF_STARTDASH) 
		and not (tracer and tracer.type == MT_TUBEWAYPOINT) 
		and player.burstcheck == 1 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
		or player.burstcheck == 1
		and not P_IsObjectOnGround(player.mo)
		and not (player.mo.eflags & MFE_JUSTHITFLOOR) 
		and player.flymeets == 204
		and not (player.mo.boat and player.mo.boat.valid)
			
			//first jump
			if player.flystep == 0
			and player.flymeets == 204
				player.justbursted = 1 
				player.flystep = 1 //you just jumped weenie congrats
				player.flymeets = 204 //just to be sure
			end
			
			//start the hover
			if player.flystep == 1 
			and player.justbursted == 0 
			and not (P_PlayerInPain(player)) 
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
			and not P_IsObjectOnGround(player.mo)
			and player.flymeets == 204
				player.justbursted = 1 
				player.flystep = 2 
				player.pflags = $1 & ~PF_JUMPED 
				player.pflags = $1 & ~PF_SPINNING			
				player.mo.state = S_FRANK_FLY
				player.mo.anim_duration = 1
				player.startthemeet = 1
				S_StartSound(player.mo, sfx_3db16)
				if player.mo.eflags & MFE_UNDERWATER
					jumpdust(player.mo, 7 << FRACBITS, MT_MEDIUMBUBBLE)
				else
					jumpdust(player.mo, 7*player.mo.scale, MT_DUST)
				end
				player.mo.momz = 0
			end
			player.burstcheck = 0
			player.usedown = 1 	
		end
		
		if (player.mo.state == S_FRANK_FLY or player.mo.state == S_FRANK_FLYTIRE) and (player.mo.eflags & MFE_UNDERWATER) and not (player.mo.eflags & MFE_TOUCHWATER) and leveltime%3 == 0
			for i = 1,2
				P_SpawnMobj(player.mo.x + (P_RandomRange(-32,32)*player.mo.scale),player.mo.y + (P_RandomRange(-32,32)*player.mo.scale),player.mo.z + 35*player.mo.scale, MT_SMALLBUBBLE)
			end
		end
		
		//the hovering
		if player.startthemeet == 1
		and player.flystep == 2
		and player.flymeets != 0
		and not (P_PlayerInPain(player))
		and player.didafunny == 0
		and player.mo.state != S_PLAY_SPRING and player.mo.state != S_PLAY_FALL and player.mo.state != S_PLAY_GASP and player.mo.state != S_PLAY_PAIN
			if not (player.cmd.buttons & BT_SPIN) and player.mo.momz <= 0
			or not (player.cmd.buttons & BT_SPIN) and player.mo.momz >= 0 and (player.mo.eflags & MFE_VERTICALFLIP)
				player.mo.momz = 0
			end			
			player.flymeets = $-1
			if (player.powers[pw_super]) //fuck you infinite flight time
			or player.solchar and player.solchar.istransformed
				player.flymeets = 204
			end
			//fix any animations
			if player.mo.state != S_FRANK_FLY and player.flymeets > 69
			and not (player.mo.eflags & MFE_UNDERWATER)
				player.mo.state = S_FRANK_FLY
			end
			if player.flymeets <= 69
			and player.mo.state != S_FRANK_FLYTIRE
				player.mo.state = S_FRANK_FLYTIRE
			end
		end
		
		if (player.cmd.buttons & BT_SPIN) //prevent gravity bullshit
		and (player.cmd.buttons & BT_JUMP)
		and player.flystep == 2
		and player.flymeets < 200
		and (player.pflags & PF_THOKKED)
			player.pflags = $1 & ~PF_THOKKED
		end

		
		//the burst
		if player.flystep == 2 
		and player.justbursted == 0 
		and not (P_PlayerInPain(player))
		and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.cmd.buttons & BT_JUMP 
		and player.usedown == 0
		and player.flymeets != 0
		and player.startthemeet == 1
		and player.flymeets <= 204
			player.mo.state = S_FRANK_FLY
			player.justbursted = 1  
			player.pflags = $ & ~PF_SPINNING
			S_StartSound(player.mo, sfx_zoom)
			P_DoJump(player, false) //so we can tie it to something thatll get multiplied with super or hyper
			player.pflags = $1 & ~PF_THOKKED
			player.pflags = $1|PF_JUMPED
			player.pflags = $1|PF_NOJUMPDAMAGE
			player.flymeets = 0
			P_SetObjectMomZ(player.mo, 6*player.mo.scale, true)
			player.squashtime = 1
			//Xmom BS
			if player.isxmomentum
				P_SetObjectMomZ(player.mo, player.speed/12, true)
			end
			//shields :)
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
				P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
				S_StartSound(player.mo, sfx_wdjump)
				jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
				jumpdust(player.mo, 16*player.mo.scale, MT_DUST)
			end
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
				P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
				S_StartSound(player.mo, sfx_s3k45)
				jumpdust(player.mo, 14*player.mo.scale, MT_SUPERSPARK)
			end
			if player.mo.eflags & MFE_UNDERWATER
				jumpdust(player.mo, 7 << FRACBITS, MT_MEDIUMBUBBLE)
			else
				jumpdust(player.mo, 7*player.mo.scale, MT_DUST)
			end
			if (twodlevel or player.mo.flags2 & MF2_TWOD)
				P_InstaThrust(player.mo, player.mo.angle, player.spedmesur + 2*FRACUNIT)
			else 
				P_InstaThrust(player.mo, (player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)), player.spedmesur + 2*FRACUNIT)
			end
			
			if player.solchar and player.solchar.istransformed
				P_Telekinesis(player, 30*player.mo.scale, 300*player.mo.scale)
				jumpdust(player.mo, 4*player.mo.scale, MT_DUST)
				jumpdust(player.mo, 10*player.mo.scale, MT_DUST)
				jumpdust(player.mo, 20*player.mo.scale, MT_TNTDUST)
				S_StartSound(player.mo, sfx_wdjump)
				player.pflags = $1 & ~PF_THOKKED
			end
			player.didafunny = 1
			player.flystep = 3
			player.flymeets = 0
		end
		
		if (player.pflags & PF_THOKKED) and (player.mo.state == S_FRANK_FLY or player.mo.state == S_PLAY_SWIM) and player.solchar and player.solchar.istransformed
			player.pflags = $1 & ~PF_THOKKED
		end
		
		if player.flystep == 2
		and (player.cmd.buttons & BT_SPIN)
		and player.spindown == 0
			player.spindown = 1
		end
		
		//slowfall part
		if (player.cmd.buttons & BT_JUMP) 
		and player.flystep == 3
		and player.mo.momz/P_MobjFlip(player.mo) <= (player.hovrspd*player.mo.scale)
		and not (player.pflags & PF_THOKKED) 
		and not (P_PlayerInPain(player))
		and not P_IsObjectOnGround(player.mo)
		and player.mo.momz/P_MobjFlip(player.mo) != 0
			if player.mo.state == S_FRANK_FLY or player.mo.state == S_PLAY_SWIM
				if player.mo.eflags & MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, -3*FRACUNIT)
				else
					P_SetObjectMomZ(player.mo, -5*FRACUNIT)
				end
				
			end
		//the let-go part
		elseif not (player.cmd.buttons & BT_JUMP) 
		and player.flystep == 3
		and player.mo.momz/P_MobjFlip(player.mo) < (-2*player.mo.scale)
		and not (P_PlayerInPain(player))
		and not P_IsObjectOnGround(player.mo)
		and player.mo.momz/P_MobjFlip(player.mo) != 0
		and not (player.mo.eflags & MFE_JUSTHITFLOOR) 
		and player.bounceattack == 0
			player.mo.rollangle = 0
			player.mo.state = S_PLAY_FALL
			player.pflags = $1 & ~PF_CANCARRY
			player.pflags = $1 & ~PF_THOKKED
			player.pflags = $1|PF_JUMPED
			player.pflags = $1|PF_NOJUMPDAMAGE
			player.flymeets = 0
		end
		
		if player.bounceattack == 1
			player.flystep = 4
			player.flymeets = 0
		end
			
		
		//flying downward
		if (player.cmd.buttons & BT_SPIN)
		and player.flystep == 2
		and not (P_PlayerInPain(player))
			if player.mo.momz <= 0 
			or player.mo.momz >= 0 and (player.mo.eflags & MFE_VERTICALFLIP)
				player.mo.momz = $ - P_GetMobjGravity(player.mo)*3/5
			end
			player.pflags = $1|PF_THOKKED
		elseif not (player.cmd.buttons & BT_SPIN)
		and player.flystep == 2
		and not (P_PlayerInPain(player))
			player.pflags = $1 & ~PF_THOKKED
		end
		
		
		//soudn
		if leveltime % 10 == 0 and player.mo.state == S_FRANK_FLY and player.flystep == 2 and player.flymeets > 69
		or leveltime % 10 == 0 and player.mo.state == S_FRANK_FLY and player.flystep == 3
			if player.mo.eflags & MFE_UNDERWATER return end
			S_StartSound(player.mo, sfx_s3kba)
		end
		if leveltime % 10 == 0 and player.mo.state == S_FRANK_FLYTIRE and not (player.mo.eflags & MFE_UNDERWATER) and player.flystep == 2 and player.flymeets <= 69
			if player.mo.eflags & MFE_UNDERWATER return end
			S_StartSound(player.mo, sfx_s3kbb)
		end
		if (player.flymeets == 69 or player.flymeets == 54 or player.flymeets == 39 or player.flymeets == 24 or player.flymeets == 9) and player.mo.state == S_FRANK_FLYTIRE and player.flystep == 2	
			S_StartSound(player.mo, sfx_s1b6)
			P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FRANKSWET)
		end
		
		// helpful frien :)
		if not (P_PlayerInPain(player))
		and not P_IsObjectOnGround(player.mo) 
		and (player.mo.state == S_FRANK_FLY or player.mo.state == S_PLAY_SWIM)
			player.pflags = $1|PF_CANCARRY
		end
		
		//stop helping >:)
		if P_IsObjectOnGround(player.mo) 
		and (player.pflags & PF_CANCARRY)
		or (P_PlayerInPain(player))
			player.pflags = $1 & ~PF_CANCARRY
		end
		
		if P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
		or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_GASP
			player.flystep = 0
			player.flymeets = 204
		end
		
		if player.flymeets == 0
		and not (P_PlayerInPain(player))
		and player.flystep == 2
			player.mo.state = S_PLAY_FALL
			player.flystep = 3
			player.pflags = $1 & ~PF_CANCARRY
			player.mo.rollangle = 0
		end
		
		if (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
		and (player.mo.state == S_FRANK_FLY or player.mo.state == S_FRANK_FLYTIRE)
			player.mo.state = S_PLAY_STND
		end
		
		//tilting time
		if player.tiltingnow == nil then player.tiltingnow = false end
		if player.flystep == 2 or player.flystep == 3 and (player.mo.state == S_FRANK_FLY or player.mo.state == S_FRANK_FLYTIRE)
			player.tiltingnow = true
			if player.tiltroll == nil then player.tiltroll = 0 end
			player.tiltroll = $ + (player.cmd.sidemove - $)/4
			player.mo.rollangle = FixedMul(-player.tiltroll * ANG1/4, cos(R_PointToAngle(player.mo.x, player.mo.y) - (player.cmd.angleturn << 16)))
		end
		
		if not (player.mo.state == S_FRANK_FLY or player.mo.state == S_FRANK_FLYTIRE)
		and player.tiltingnow
			player.mo.rollangle = 0
			player.tiltroll = 0
			player.tiltingnow = false
		end

		//making sure things dont get fuckd
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
		or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_GASP
			player.burstcheck = 0 
		end
		
		//reset everything if carried
		if player.powers[pw_carry]
		or player.powers[pw_carry] == CR_MACESPIN
			player.elefix = 0
			player.flystep = 0 
			player.startthemeet = 0
			player.flymeets = 204
			player.didafunny = 0
			player.mo.rollangle = 0
		end
		
		//pain makes the bar go away
		if (P_PlayerInPain(player))
		or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_GASP
			player.flymeets = 0
		end
		
		//self explanatory
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.burstcheck = 0 
		end
		
		//stop freaking out when you jump the second you hit the ground
		if (player.mo.eflags & MFE_JUSTHITFLOOR) and player.cmd.buttons & BT_JUMP
		or (player.mo.eflags & MFE_JUSTHITFLOOR) and player.pflags & PF_JUMPED	
		or P_IsObjectOnGround(player.mo) and player.pflags & PF_JUMPED
			player.flystep = 1
		end
		
		//...how the fuck did you manage to land while in a pose
		if P_IsObjectOnGround(player.mo) and (player.mo.state == S_FRANK_BOUNCE or player.mo.state == S_FRANK_SBOUNCE)
			player.mo.state = S_PLAY_WALK
		end
	
		//fake flying fix
		if player.mo.state == S_FRANK_FLY
		and not P_IsObjectOnGround(player.mo)
		and player.flystep == 0
			player.mo.state = S_PLAY_FALL
			player.mo.rollangle = 0
		end
		
		if (player.mo.state == S_FRANK_FLY or player.mo.state == S_FRANK_FLYTIRE)
		and P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_STND
		end
		
		if player.powers[pw_carry] == CR_ROLLOUT
		and (player.mo.state == S_FRANK_FLY or player.mo.state == S_FRANK_FLYTIRE or player.mo.state == S_PLAY_FALL)
			player.mo.state = S_PLAY_STND
		end
		
		//fake rolling
		if (player.pflags & PF_SPINNING)
		and P_IsObjectOnGround(player.mo)
		and player.mo.state != S_PLAY_ROLL
		and not (player.pflags & PF_JUMPED)
			if player.mo.state == S_PLAY_SPINDASH return end
			S_StartSound(player.mo, sfx_spin)
			player.mo.state = S_PLAY_ROLL
		end
	else
		if multiplayer
			player.flymeets = 0
			player.flystep = 0
		end
	end
end)

//'Le Ground Bounce
addHook("PlayerThink", function(player)
	if player.bot == 1 return end
	if srb2p return end
	
	if player.mo and player.mo.valid
	and (player.mo.skin == "frank")
	and player.playerstate == PST_LIVE	
		if player.bounceattack == nil 
			player.bounceattack = 0 
		end		
		
		if (player.mo.state == S_FRANK_BOUNCE or player.mo.state == S_FRANK_SBOUNCE)
			if (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
			or not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 0
				if player.mo.frame == 17
					S_StartSound(player.mo, sfx_cdfm16)
					P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FADS)
				end
				player.mo.state = S_PLAY_FALL
			end
		end
		
		if player.bouncenumber == nil 
		or player.mo.state == S_PLAY_PAIN
			player.bouncenumber = 0 
			player.justchangedbouncenumber = 0
			if player.mo.state == S_PLAY_PAIN then player.bounceattack = 0 end
		end
		
		
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
		and player.bounceattack == 0 
			player.justattract = 0
			player.bouncenumber = 0
			player.divesquasher = 0
			if player.justchangedbouncenumber != 0
				player.justchangedbouncenumber = 0
			end
		end
		
		if player.squashtime == nil
			player.squashtime = 0
		end
		
		if player.trulyspedbnce == nil
		or not (P_IsObjectOnGround(player.mo)) //measure momz
			player.trulyspedbnce = 0
		end
		
		if (player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_HYPERTRNS_1)
			player.bounceattack = 0
			player.pflags = $1|PF_THOKKED
			player.pflags = $1 & ~PF_JUMPED
		end
		
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)) and player.divesquasher != 0
			player.mo.spriteyscale = FRACUNIT
			player.mo.spritexscale = FRACUNIT
			player.divesquasher = 0
		end
		
		if player.pflags & PF_JUMPED
		and player.spindown == 0 
		and not (player.pflags & PF_THOKKED) 
		and not (P_IsObjectOnGround(player.mo)) 
		and player.cmd.buttons & BT_SPIN 
		and player.bouncenumber != 2
		and player.bounceattack == 0 
		and not (player.exiting) 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
		and player.bouncenumber == 0
		and player.powers[pw_carry] != CR_MACESPIN
		and not player.powers[pw_carry]
		and not ((player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and player.pflags & PF_SHIELDABILITY)
		and player.flystep != 2
			player.mo.rollangle = 0
			player.pflags = $1|PF_THOKKED
			player.pflags = $1 & ~PF_STARTJUMP
			player.pflags = $1 & ~PF_CANCARRY
			player.mo.state = S_PLAY_JUMP
			player.bounceattack = 1 
			player.pflags = $1 & ~PF_NOJUMPDAMAGE
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
			player.divesquasher = 1
			if (player.mo.momz <= -2*FRACUNIT) //use it while falling at a certain speed
				P_SetObjectMomZ(player.mo, -20*FRACUNIT, true)
			else //use it while going up
				if (player.powers[pw_super])
					P_SetObjectMomZ(player.mo, -30*FRACUNIT)
				else 
					P_SetObjectMomZ(player.mo, -20*FRACUNIT)
				end
			end
			//shield boosts
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			or (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
				P_SetObjectMomZ(player.mo, -5*FRACUNIT, true)
				player.pflags = $1|PF_SHIELDABILITY
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
					S_StartSound(player.mo, sfx_s3k44)
				end
			elseif (player.powers[pw_shield] & SH_FORCE)
				S_StartSound(player.mo, sfx_ngskid)
				player.pflags = $1|PF_SHIELDABILITY
				player.mo.momx = $*1/2
				player.mo.momy = $*1/2
			end
			//attract
			local attraclook = P_LookForEnemies(player, false, false)
			player.mo.target = attraclook
			player.mo.tracer = attraclook
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and attraclook and attraclook.valid and player.spindown == 0 and not (player.mo.eflags & MFE_SPRUNG)
				player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, attraclook.x, attraclook.y)
				player.homing = 2*TICRATE
				player.pflags = $1|PF_SHIELDABILITY
				S_StartSound(player.mo, sfx_s3k40)
				player.mo.state = S_PLAY_ROLL
				player.bounceattack = 0
				player.spindown = 1
				player.justattract = 1
			end
			S_StartSound(player.mo, sfx_cdfm62)
		end	
		//attracts jump
		if player.justattract == 1
		and player.mo.momz > 0
		and player.homing == 0
			P_SetObjectMomZ(player.mo, 8*FRACUNIT, true)
			player.speed = player.speed * 4/5
			player.mo.state = S_PLAY_SPRING
			S_StartSound(player.mo, sfx_s3k45)
			jumpdust(player.mo, 15*player.mo.scale, MT_SUPERSPARK)
			explodelol(player.mo, player.mo, 130*player.mo.scale, player, false, false)
			player.justattract = 0
			player.pflags = $1 & ~PF_JUMPED
			player.pflags = $1 & ~PF_THOKKED
		end
		
		if player.bounceattack == 1		
		
			if (player.mo.momz >= -30*FRACUNIT)
				player.trulyspedbnce = 1
			elseif (player.mo.momz < -30*FRACUNIT)
				player.trulyspedbnce = 0
			end
		
			player.pflags = $1|PF_JUMPSTASIS
		
			//trails
			local divetrail = P_SpawnGhostMobj(player.mo)
			divetrail.color = player.mo.color
			divetrail.colorized = true
			divetrail.blendmode = AST_ADD
			divetrail.spritexscale = player.mo.spritexscale
			divetrail.spriteyscale = player.mo.spriteyscale
			if not (P_IsObjectOnGround(player.mo))
			and player.mo.state == S_PLAY_JUMP
				if not (leveltime % 2) then
					P_SpawnGhostMobj(divetrail)
				end
			end
			
			//sproing
			if player.mo.eflags & MFE_SPRUNG
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.bouncenumber = 7
				player.mo.momz = $*5/4
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				S_StartSound(player.mo, sfx_sprong)
				player.bounceattack = 0
			end
			
			//break da groudn
			local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
			if sectorthing.valid then
				for fof in sectorthing.ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
					and not player.powers[pw_carry]
					and (abs(fof.topheight - player.mo.z) <= 30*player.mo.scale) then
						EV_CrumbleChain(player.sectorthing, fof)
					end
				end
			end
			
			if player.mo.momz > 0  and not (player.mo.eflags & MFE_VERTICALFLIP) and not (player.mo.eflags & MFE_SPRUNG) and player.mo.state == S_PLAY_JUMP and (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			or player.mo.momz < 0  and (player.mo.eflags & MFE_VERTICALFLIP) and not (player.mo.eflags & MFE_SPRUNG) and player.mo.state == S_PLAY_JUMP and (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
				player.mo.momz = $ * -1
			end
			
			//STREEEEEEEEEETCH!!
			if player.divesquasher < 4*TICRATE and player.divesquasher >= 1 and player.mo.spritexscale > FRACUNIT/5
				player.divesquasher = $+1
				player.mo.spritexscale = $ - FRACUNIT/(player.divesquasher + 55)
				player.mo.spriteyscale = $ + FRACUNIT/(player.divesquasher + 55)
			end
			
			//enemy bounce
			if player.mo.momz > 0  and not (player.mo.eflags & MFE_VERTICALFLIP) and not (player.mo.eflags & MFE_SPRUNG) and player.mo.state == S_PLAY_JUMP and (player.powers[pw_shield] & SH_NOSTACK) != SH_ELEMENTAL
			or player.mo.momz < 0  and (player.mo.eflags & MFE_VERTICALFLIP) and not (player.mo.eflags & MFE_SPRUNG) and player.mo.state == S_PLAY_JUMP and (player.powers[pw_shield] & SH_NOSTACK) != SH_ELEMENTAL
				//s q u a s h
				player.mo.spriteyscale = FRACUNIT
				player.mo.spritexscale = FRACUNIT
				player.divesquasher = 0
				player.squashtime = 1
				
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1|PF_THOKKED
				player.spindown = 1 
				setpose(player.mo, player)
				player.bounceattack = 0
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
					P_SetObjectMomZ(player.mo, -3*FRACUNIT, true) //take away some of the faster dive
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
				end
				if player.trulyspedbnce == 1
					player.mo.momz = $*3/5
				end
				//dust
				if player.mo.eflags & MFE_UNDERWATER
					player.mo.momz = $*3/5
					jumpdust(player.mo, 7 << FRACBITS, MT_MEDIUMBUBBLE)
					if (player.powers[pw_super])
						jumpdust(player.mo, 15*player.mo.scale, MT_SUPERSPARK)
					end
				else
					if (player.powers[pw_super])
						jumpdust(player.mo, 15*player.mo.scale, MT_SUPERSPARK)
					else
						jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
					end
				end
			end
		end
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP //damn it bubble >:(
		and not (player.pflags & PF_SHIELDABILITY)
		and player.mo.state == S_PLAY_ROLL
		and not (player.pflags & PF_SPINNING)
			setpose(player.mo, player)
			player.mo.momz = $*4/6
			if player.mo.eflags & MFE_UNDERWATER
				player.mo.momz = $*3/5
				jumpdust(player.mo, 7 << FRACBITS, MT_MEDIUMBUBBLE)
				if (player.powers[pw_super])
					jumpdust(player.mo, 15*player.mo.scale, MT_SUPERSPARK)
				end
			else
				if (player.powers[pw_super])
					jumpdust(player.mo, 15*player.mo.scale, MT_SUPERSPARK)
				else
					jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
				end
			end
		end
		//landing
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) 
		and player.bounceattack == 1 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
		and not ((player.mo.eflags & MFE_SPRUNG) and (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL)
			if player.justchangedbouncenumber == 0  
				//s q u a s h
				player.mo.spriteyscale = FRACUNIT
				player.mo.spritexscale = FRACUNIT
				player.divesquasher = 0
				player.squashtime = 1
				
				player.justchangedbouncenumber = 1 
				player.bouncenumber = 1 
				player.pflags = $ & ~PF_JUMPED 
				player.pflags = $1|PF_THOKKED
				player.pflags = $ & ~PF_SPINNING
				player.flystep = 4
				setpose(player.mo, player)
				// rising time
				if (player.powers[pw_super])
				or player.solchar and player.solchar.istransformed
					P_SetObjectMomZ(player.mo, 16*FRACUNIT)
					if not (player.solchar and player.solchar.istransformed)
						explodelol(player.mo, player.mo, 180*player.mo.scale, player, true, true)
					end
					S_StartSound(player.mo, sfx_s3k96)
					P_StartQuake(20*FRACUNIT, 5)
				else 
					P_SetObjectMomZ(player.mo, 12*FRACUNIT)
					explodelol(player.mo, player.mo, 100*player.mo.scale, player, true, false)
				end
				if player.hyper and player.hyper.capable and player.powers[pw_super]
					P_SetObjectMomZ(player.mo, 19*FRACUNIT)
					explodelol(player.mo, player.mo, 250*player.mo.scale, player, true, true)
					S_StartSound(player.mo, sfx_s3k96)
				end
				S_StartSound(player.mo, sfx_frbnce)
				
				if S_SoundPlaying(player.mo, sfx_spndsh)
					S_StopSoundByID(player.mo, sfx_spndsh)
				end
				
				if player.mo.eflags & MFE_UNDERWATER //water nerfing
					player.mo.momz = $*3/5
				end
				
				//dust
				if player.mo.eflags & MFE_UNDERWATER
					jumpdust(player.mo, 7 << FRACBITS, MT_MEDIUMBUBBLE)
					if (player.powers[pw_super])
						jumpdust(player.mo, 15*player.mo.scale, MT_SUPERSPARK)
					end
				else
					if (player.powers[pw_super])
						jumpdust(player.mo, 15*player.mo.scale, MT_SUPERSPARK)
					else
						jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
					end
				end
				
				if player.solchar and player.solchar.istransformed //JOHN DO THE WINDY THING
					P_Telekinesis(player, 32*player.mo.scale, 330*player.mo.scale)
					jumpdust(player.mo, 4*player.mo.scale, MT_DUST)
					jumpdust(player.mo, 10*player.mo.scale, MT_DUST)
					jumpdust(player.mo, 20*player.mo.scale, MT_TNTDUST)
					explodelol(player.mo, player.mo, 150*player.mo.scale, player, true, true) //its weaker because of the free wind dummy
					S_StartSound(player.mo, sfx_wdjump)
				end
				
				//shieldz
				if not (player.mo.eflags & MFE_SPRUNG)
					if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL // slam down and drop fire; no enemy bouncing
						P_ElementalFire(player, true)
						S_StartSound(player.mo, sfx_s3k4c)
						P_StartQuake(20*FRACUNIT, 5)
						S_StartSound(player.mo, sfx_s3k96)
					elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON //nuke when land, and launch you more upward
						P_NukeEnemies(player.mo, player.mo, 800*player.mo.scale)
						P_FlashPal(player, PAL_NUKE, 10)
						local boom = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FADBOOM)
						boom.scale = 3/2*FRACUNIT
						player.powers[pw_shield] = SH_NONE
						S_StartSound(player.mo, sfx_bkpoof)
						P_StartQuake(20*FRACUNIT, 5)
						player.mo.state = S_PLAY_PAIN
						P_SetObjectMomZ(player.mo, 6*FRACUNIT, true) --give a little bonus, sure
						player.mo.momx = $/15
						player.mo.momy = $/15
					elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
						P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA //gain speed after the bounce
						P_InstaThrust(player.mo, player.mo.angle, player.speed + (player.speed/3)) 
						if player.speed > 0
							player.pflags = $1|PF_SHIELDABILITY
							S_StartSound(player.mo, sfx_s3k43)
						end
					end
				end
			end
			player.bounceattack = 0 
			player.spindown = 1 
			player.pflags = $1 & ~PF_THOKKED
		end			
		
		//s t r e t c h	
		if player.squashtime >= 1 and player.divesquasher == 0
			player.squashtime = $+1	
			if player.squashtime == 2 //squash
				player.mo.spritexscale = FRACUNIT*(3)
				player.mo.spriteyscale = FRACUNIT/(6)
			else
				if player.squashtime <= (4)
					player.squishfactor = 5
				else
					player.squishfactor = (player.squashtime + 20)
				end
				player.mo.spritexscale = $ - FRACUNIT/player.squishfactor - FRACUNIT/10
				player.mo.spriteyscale = $ + FRACUNIT/player.squishfactor
			end
			
			if player.mo.spritexscale < FRACUNIT and player.squashtime != 0
				player.mo.spritexscale = FRACUNIT
			end	
			if player.mo.spriteyscale > FRACUNIT and player.squashtime != 0
				player.mo.spriteyscale = FRACUNIT
			end
			
			if not (player.mo.state == S_FRANK_BOUNCE or player.mo.state == S_FRANK_SBOUNCE or player.mo.state == S_FRANK_FLY or player.mo.state == S_PLAY_JUMP) and player.squashtime != 0
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.squashtime = 0
			end
		end
		if (player.mo.state == S_PLAY_DEAD or player.mo.state == S_PLAY_DRWN)
		and (player.mo.spritexscale != FRACUNIT or player.mo.spriteyscale != FRACUNIT)
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
		end
		
		//some quick checks
		if player.bounceattack == 1 
		and (not player.mo.health or (P_PlayerInPain(player)))
			player.bounceattack = 0 
		end
		if player.bounceattack == 1 
			player.pflags = $1 & ~PF_SPINNING 
		end
		if player.powers[pw_carry]
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
			player.bounceattack = 0 
		end
		if player.mo.eflags & MFE_GOOWATER
		and player.bounceattack == 1
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
			player.bounceattack = 2
		end
		
		if player.homing != 0
		and player.pflags & PF_NOJUMPDAMAGE
			if player.mo.state != S_PLAY_ROLL
				player.mo.state = S_PLAY_ROLL
			end
			player.pflags = $1 & ~PF_NOJUMPDAMAGE
		end
			
		
		if player.powers[pw_carry] == CR_ROLLOUT
		and(player.mo.eflags & MFE_JUSTHITFLOOR)
			if player.bouncenumber > 0
				player.bouncenumber = 0
				player.bounceattack = 0
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINNING
				player.mo.state = S_PLAY_STND
			end
		end
		if player.powers[pw_carry] == CR_ROLLOUT //stop rolling on it
		and player.mo.state == S_PLAY_ROLL
			player.mo.state = S_PLAY_STND
		end
		
		if not (player.pflags & PF_JUMPED) 
			player.bounceattack = 0 
		end
		
		if player.bounceattack == 1 //thats the wrong animation dickwad
		and player.mo.state != S_PLAY_JUMP
			player.mo.state = S_PLAY_JUMP
			player.pflags = $1 & ~PF_NOJUMPDAMAGE
			player.pflags = $1|PF_THOKKED
			player.flystep = 4
			player.flymeets = 0
		end
		
		//dont use these before you land
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
		and player.pflags & PF_SHIELDABILITY
			local floor = P_FloorzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height)
			local z = player.mo.z
			if (player.mo.eflags&MFE_VERTICALFLIP)
				z = player.mo.z+player.mo.height
				if player.mo.ceilingz == floor
					floor = player.mo.floorz
				else
					floor = player.mo.ceilingz
				end
			end
			if abs(z-floor) <= abs(player.mo.momz)
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
				and player.mo.state == S_PLAY_ROLL
				and player.bouncenumber == 1
					setpose(player.mo, player)
				end
				player.pflags = $ & ~PF_SHIELDABILITY
			end
		end
		
		if player.gotflag -- nooo more abilities! CTF is finally balanced once again
			player.flystep = 69
			player.bouncenumber = 420
		end
		
		if S_SoundPlaying(player.mo, sfx_frsksp)
			if P_PlayerInPain(player)
			or (player.mo.eflags & MFE_SPRUNG)
			or not player.mo.health
			or player.gotflag
			or player.mo.state == S_PLAY_PAIN
				S_StopSoundByID(player.mo, sfx_frsksp)
				player.pflags = $ & ~PF_JUMPED 
				player.pflags = $ & ~PF_SPINNING
				player.pflags = $1|PF_THOKKED
				player.mo.flags = $1 & ~MF_BOUNCE
			end
		end
	end
end, MT_PLAYER)

//sleep times
addHook("ShouldJingleContinue", function(player, musname)
	if true return end
	if musname != "FSLEEP"  return end
	if player.mo.skin != "frank" return end
	if player.pirhanaplantmusic == false return end
	if player and player.mo and player.mo.skin == "frank" and player.mo.state == S_FRANK_SLEEP
		return true
	else
		return false
	end
end)

addHook("PlayerThink", function(player)
	if srb2p return end	
	if player.mo and player.mo.valid and player.mo.skin == "frank"	
	
		//i'll borrow you real quick.
		if player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1
			if not S_SoundPlaying(player.mo, sfx_frwind)
				S_StartSoundAtVolume(player.mo, sfx_frwind, 35)
			end
			if leveltime % 5 == 0 and player.mo.state != S_PLAY_SUPER_TRANS1
				player.randtrands = P_RandomRange(1,4)
				local dust1 = P_SpawnMobj(player.mo.x + (P_RandomRange(-25,25)*player.mo.scale),player.mo.y + (P_RandomRange(-25,25)*player.mo.scale),player.mo.z + (P_RandomRange(-10,60)*player.mo.scale),MT_SPINDUST)
				dust1.scale = P_RandomRange(1,2)*player.mo.scale
				if dust1.scale == player.mo.scale
					if player.randtrands == 1
						dust1.frame = FF_FULLBRIGHT|TR_TRANS10
					elseif player.randtrands == 2
						dust1.frame = FF_FULLBRIGHT|TR_TRANS20
					elseif player.randtrands == 3
						dust1.frame = FF_FULLBRIGHT|TR_TRANS30
					else
						dust1.frame = FF_FULLBRIGHT|TR_TRANS40
					end
				elseif dust1.scale == 2*player.mo.scale
					if player.randtrands == 1
						dust1.frame = FF_FULLBRIGHT|TR_TRANS30
					elseif player.randtrands == 2
						dust1.frame = FF_FULLBRIGHT|TR_TRANS40
					elseif player.randtrands >= 3
						dust1.frame = FF_FULLBRIGHT|TR_TRANS50
					end
				end
				dust1.momz = P_RandomRange(1,3)*player.mo.scale
			end
		end
		
		if player.boatcheckrz == nil
			player.boatcheckrz = 0
		end
		
		if not (player.mo.boat and player.mo.boat.valid)
		and player.boatcheckrz == 1
			S_StartSound(player.mo, sfx_fadswp)
			P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FADS)
			player.boatcheckrz = 0
		end
		
		if player.mo.boat and player.mo.boat.valid
		and player.boatcheckrz == 0
			S_StartSound(player.mo, sfx_fadswp)
			P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FADS)
			player.boatcheckrz = 1
		end
		
		if player.waittimers == nil
			player.waittimers = 0
			player.sleepmusic = 0
			player.confirmsleep = 0
			player.slepsfx = 0
		end
		
		if player.mo.state == S_PLAY_WAIT //countdown
			player.waittimers = $ + 1
		end
		
		
		if player.waittimers == 2000 // Exactly a minute lol
			player.waittimers = 2001
			player.mo.state = S_FRANK_TIRED
			player.sleepmusic = 1
			player.confirmsleep = 1
		end
		
		if player.sleepmusic == 1 // cue song
		and player.mo.state == S_FRANK_SLEEP
			if player.pirhanaplantmusic == true
				P_PlayJingleMusic(player, "FSLEEP", nil, true, JT_OTHER)
			end
			player.sleepmusic = 0
			player.slepsfx = 1
		end
		
		//snore
		if player.mo.state == S_FRANK_SLEEP
		and not S_SoundPlaying(player.mo, sfx_frslep)
			S_StartSound(player.mo, sfx_frslep)
		end
		if S_SoundPlaying(player.mo, sfx_frslep) and player.mo.sprite2 != SPR2_CNT1
			S_StopSoundByID(player.mo, sfx_frslep)
		end
		
		//Wake up
		if player.mo.state != S_PLAY_WAIT
		or player.frankgroovin
		or player.mo.sprite2 == SPR2_FROZ
		or (player.mo.state == S_PLAY_BANANA or player.mo.state == S_PLAY_2POINT1 or player.mo.state == S_PLAY_FRCHAIR1 or player.mo.state == S_PLAY_FRCHAIR2 or player.mo.state == S_PLAY_CLUBPENG2 or player.mo.state == S_FRANK_TPOSE or player.mo.state == S_PLAY_JEVIL or player.mo.state == S_PLAY_DSPIN or player.mo.state == S_PLAY_CLUBPENG or player.mo.state == S_PLAY_HDANCE or player.mo.state == S_PLAY_DHELP or player.mo.state == S_PLAY_SPOOKDANCE)
			player.waittimers = 0
		end

		if player.speed > 0  //walkd
		and (player.mo.state == S_FRANK_SLEEP or player.mo.state == S_FRANK_TIRED)
			player.waittimers = 0
			P_RestoreMusic(player)
			player.mo.state = S_PLAY_WALK
		end

		if (player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPINDASH or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_FALL)
		and player.confirmsleep == 1
			player.waittimers = 0
			P_RestoreMusic(player)
			player.confirmsleep = 0
		end
	end
	
	if player.mo and player.mo.valid
	and player.mo.skin != "frank" //imagine not sleeping
	and player.confirmsleep == 1
		P_RestoreMusic(player) 
		player.waittimers = 0
		player.mo.state = S_PLAY_STND
		player.confirmsleep = 0
	end
end)

addHook("PlayerSpawn", function(player)
	if player.waittimers == 2001
		P_RestoreMusic(player)
	end
	player.waittimers = 0
end)

//battle time
freeslot("S_FRSKATE0", "MT_FRANKSKATERING", "MT_FRANKSKATEBOARDEAPON", "MT_FRAREFLECT_HITBOX", "s_FRAREFLECT_HITBOX")
mobjinfo[MT_FRAREFLECT_HITBOX] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_FRAREFLECT_HITBOX,
	deathstate = S_NULL,
	radius = 55*FRACUNIT,
	height = 75*FRACUNIT,
	mass = DMG_NUKE,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_FRAREFLECT_HITBOX] = {SPR_NULL, 0, -1, NULL, 0, 0, S_NULL}

local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle 
		then
		ScriptLoaded = true 
		local B = CBW_Battle 
				

		local SoupGB = function(mo,doaction)
			local player = mo.player
			
			player.actiontext = "SkateNado"
			player.actionrings = 10
			player.action2text = nil 
			player.action2rings = 0 
			
			
			if not(B.CanDoAction(player)) 
				player.actionstate = 0 
				return end	

			if player.actionstate == 0 
			and player.flystep < 2
			and not (player.pflags & PF_THOKKED)  
				if doaction == 1 
					player.actionstate = 1  
					player.actiontime = 0
					B.PayRings(player) 
					S_StartSound(mo,sfx_s3k3c)	
				end
			end
			
			if player.actionstate == 1 --windup
				player.flystep = 4
				player.flymeets = 0
				player.actiontime = $+1
				if player.actiontime == 1
					P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
					player.mo.state = S_FRANK_SKATESWING
				end
				
				if player.actiontime == 4 and player.mo.state == S_FRANK_SKATESWING
					player.mo.frame = 1
				end
				
				if player.actiontime == 16 and player.mo.state == S_FRANK_SKATESWING
					player.mo.frame = 2
				end
				
				if P_IsObjectOnGround(player.mo)
					P_SetObjectMomZ(player.mo, 5*FRACUNIT, false)
					S_StartSound(player.mo, sfx_s1b4)
					player.mo.state = S_FRANK_SKATESWING
				end
				
				if player.actiontime >= 18 //(half a second!)
					player.actionstate = 2
					player.actiontime = 0
					S_StartSound(player.mo, sfx_frsksp)			
				end
			end
			
			if player.actionstate == 2 --The Midair junk
				player.flystep = 4
				player.flymeets = 0
				player.mo.flags = $1|MF_BOUNCE
				if player.mo.state != S_FR_SKATESPIN
					player.mo.state = S_FR_SKATESPIN
				end
				if player.actiontime == 0 //frame one baby
					local hURtbox = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_FRAREFLECT_HITBOX)
					hURtbox.color = player.mo.color
					hURtbox.target = player.mo
					hURtbox.scale = player.mo.scale
				end
				
				if P_IsObjectOnGround(player.mo)
				or player.powers[pw_pushing]
					if P_IsObjectOnGround(player.mo) then P_SetObjectMomZ(player.mo, 5*FRACUNIT, true) end
					S_StartSound(player.mo, sfx_s1b4)
				end
				player.actiontime = $+1
				if player.mo.momz <= 0
				or player.mo.momz >= 0 and (player.mo.eflags & MFE_VERTICALFLIP)
					player.mo.momz = 0
				end		
				player.pflags = $1|PF_JUMPED|PF_DRILLING
				if player.actiontime >= 3*TICRATE
					player.actionstate = 3
				end
			end
			
			if player.actionstate == 3 //throw
				player.skatefaller = 10
				P_SetObjectMomZ(player.mo, 3*FRACUNIT, false)
				P_InstaThrust(player.mo, player.mo.angle, -3*FRACUNIT)
					
				local board = P_SpawnMobjFromMobj(mo, 0,0,0, MT_FRANKSKATEBOARDEAPON)
				board.fuse = 6*TICRATE
				board.target = player.mo
				board.color = player.mo.color
				board.angle = player.mo.angle
				board.scale = $*(5/2)
				board.hit_sound = sfx_fadswp
				S_StartSound(player.mo, sfx_mario7)
				P_SetObjectMomZ(board, 1*FRACUNIT, false)
				P_InstaThrust(board, board.angle, player.speed + 35*player.mo.scale)
				B.ApplyCooldown(player,TICRATE*4)
				player.pflags = $ & ~PF_JUMPED 
				player.pflags = $ & ~PF_SPINNING
				player.pflags = $1|PF_THOKKED
				player.actionstate = 0
				player.actiontime = 0
				player.mo.flags = $1 & ~MF_BOUNCE
 
			end
			if player.skatefaller == nil
				player.skatefaller = 0
			end
			if player.skatefaller > 1
				player.skatefaller = $ - 1
				player.mo.state = S_PLAY_WALK
				player.mo.frame = 2
			end
			if player.skatefaller == 1
				player.mo.state = S_PLAY_FALL
				player.skatefaller = 0
			end
			
			//prevent abilities
			if player.actionstate != 0
				player.bouncenumber = 4
			end
		end
			
		
		local PriorityFrank = function(player)
			if player.actionstate == 1
				B.SetPriority(player,0,2,nil,0,2,nil)  -- so you cant get knocked out of this by a light tap
			end
			if player.actionstate == 2
				B.SetPriority(player,2,3,nil,1,4,"SkateNado slap")
			end
			if player.bounceattack == 1 or player.justchangedbouncenumber == 1 and player.bouncenumber != 1
				B.SetPriority(player,2,2,nil,1,4,"Ground Bounce")
			end
			if player.bouncenumber == 1 -- GET HIS ASS
				B.SetPriority(player,0,0,nil,0,0,nil)
			end
		end
		
		local ExhaustFrank = function(player) --fine, i'll nerf it >:(
			if player.flystep == 2
			and player.flymeets >= 200
				player.flymeets = 120
				return true
			end
			return false
		end
		
		local CollideFrank = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)			
			if plr[n1] and plr[n1].valid and plr[n1].actionstate == 2 
				S_StartSound(mo[n1], sfx_hit02)
			end
		end
		
		CBW_Battle.SkinVars["frank"] = {
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
			weight = 125,
			special = SoupGB,
			guard_frame = 1,
			func_priority_ext = PriorityFrank,
			func_exhaust = ExhaustFrank,
			func_collide = CollideFrank,
		}
	end
end)

addHook("MobjCollide", function(mo, inflictor)
	if inflictor.valid
	and ((inflictor.flags & MF_MISSILE) or (inflictor.type == MT_UNIBALL))
	and not (inflictor.z > mo.z+mo.height) and not (mo.z > inflictor.z+inflictor.height)
	and (mo.target) and not (inflictor.target and (inflictor.target == mo.target))
		inflictor.color = mo.color
		inflictor.momx = -inflictor.momx
		inflictor.momy = -inflictor.momy
		inflictor.momz = -inflictor.momz
		inflictor.flags = $|MF_MISSILE
		inflictor.target = mo.target
		S_StartSound(inflictor, sfx_s3kae)
		for i = 1, 5
			local sparkxs = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_SUPERSPARK)
			sparkxs.color = inflictor.color
			sparkxs.colorized = true
			sparkxs.momx = P_RandomRange(-10, 10)*FRACUNIT
			sparkxs.momy = P_RandomRange(-10, 10)*FRACUNIT
			sparkxs.momz = P_RandomRange(-6, 6)*FRACUNIT
		end
		if (inflictor.fuse)
			inflictor.fuse = max(TICRATE, inflictor.fuse)
		end
	end
	
	return false
end, MT_FRAREFLECT_HITBOX)

addHook("MobjThinker", function(thebox)
	if (thebox.target) and thebox.target.player and (thebox.target.state == S_FR_SKATESPIN)
		A_CapeChase(thebox, 10*FRACUNIT,0)
	else
		pcall(P_RemoveMobj, thebox)
	end
end, MT_FRAREFLECT_HITBOX)

addHook("MobjThinker", function(skateres)
	if (skateres) and skateres.valid
		local divetrail = P_SpawnGhostMobj(skateres)
		divetrail.color = skateres.color
		divetrail.colorized = true
		divetrail.blendmode = AST_ADD
		divetrail.fuse = 5
		
		if not (leveltime % 2) then
			P_SpawnGhostMobj(divetrail)
		end
		if P_IsObjectOnGround(skateres)
			P_SetObjectMomZ(skateres, 4*FRACUNIT, false)
			S_StartSound(skateres, sfx_s1bb)
			jumpdust(skateres, 5*skateres.scale, MT_DUST)
			for i = 1, 3
				local sparkxs = P_SpawnMobj(skateres.x, skateres.y, skateres.z, MT_SUPERSPARK)
				sparkxs.color = skateres.color
				sparkxs.colorized = true
				sparkxs.momx = P_RandomRange(-10, 10)*FRACUNIT
				sparkxs.momy = P_RandomRange(-10, 10)*FRACUNIT
				sparkxs.momz = P_RandomRange(0, 8)*FRACUNIT
			end
		end
	end
end, MT_FRANKSKATEBOARDEAPON)

mobjinfo[MT_FRANKSKATERING] = {
	spawnstate = S_FRSKATE0,
	xdeathstate = S_MINE_BOOM1,
	painchance = 150*FRACUNIT,
	speed = 35*FRACUNIT,
	radius = 24*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
}
mobjinfo[MT_FRANKSKATERING].name = "Skateboard"
addHook("MobjThinker", function(skateres)
	if skateres.timer == nil
		skateres.timer = 6*TICRATE
	end
	skateres.timer = $ - 1
	if skateres.timer == 0
		pcall(P_RemoveMobj, skateres)
	end
	if (skateres) and skateres.valid
		local divetrail = P_SpawnGhostMobj(skateres)
		divetrail.color = skateres.color
		divetrail.colorized = true
		divetrail.blendmode = AST_ADD
		divetrail.fuse = 5
		if not (leveltime % 2) and skateres.timer > 1 then
			P_SpawnGhostMobj(divetrail)
		end
		if P_IsObjectOnGround(skateres)
			P_SetObjectMomZ(skateres, 4*FRACUNIT, false)
			S_StartSound(skateres, sfx_s1bb)
			jumpdust(skateres, 5*skateres.scale, MT_DUST)
			for i = 1, 3
				local sparkxs = P_SpawnMobj(skateres.x, skateres.y, skateres.z, MT_SUPERSPARK)
				sparkxs.color = skateres.color
				sparkxs.colorized = true
				sparkxs.momx = P_RandomRange(-10, 10)*FRACUNIT
				sparkxs.momy = P_RandomRange(-10, 10)*FRACUNIT
				sparkxs.momz = P_RandomRange(0, 8)*FRACUNIT
			end
		end
	end
end, MT_FRANKSKATERING)