freeslot("S_PLAY_BANANA", "SPR2_CLB2", "S_PLAY_2POINT1", "S_PLAY_FRCHAIR1", "S_PLAY_FRCHAIR2", "S_PLAY_CLUBPENG2", "S_FRANK_TPOSE", "SPR2_TPOS", "SPR2_JEVL", "SPR2_CLUB", "SPR2_NATH",  "SPR2_SPKY", "S_PLAY_SPOOKDANCE", "S_PLAY_DHELP", "S_PLAY_HDANCE", "S_PLAY_CLUBPENG", "S_PLAY_JEVIL", "S_PLAY_DSPIN")
states[S_PLAY_JEVIL] = {SPR_PLAY, SPR2_JEVL, 2, nil, 0, 0, S_PLAY_JEVIL}
states[S_PLAY_DSPIN] = {SPR_PLAY, SPR2_GLID, 3, nil, 0, 0, S_PLAY_DSPIN}
states[S_PLAY_CLUBPENG] = {SPR_PLAY, SPR2_CLUB|FF_ANIMATE, 183, nil, 60, 3, S_PLAY_CLUBPENG2}
states[S_PLAY_CLUBPENG2] = {SPR_PLAY, SPR2_CLB2|FF_ANIMATE, 114, nil, 37, 3, S_PLAY_CLUBPENG}
states[S_PLAY_HDANCE] = {SPR_PLAY, SPR2_CLNG, 5, nil, 0, 0, S_PLAY_HDANCE}
states[S_PLAY_DHELP] = {SPR_PLAY, SPR2_NATH, 2, nil, 0, 0, S_PLAY_DHELP}
states[S_PLAY_SPOOKDANCE] = {SPR_PLAY, SPR2_SPKY, 3, nil, 0, 0, S_PLAY_SPOOKDANCE}
states[S_FRANK_TPOSE] = {SPR_PLAY, SPR2_TPOS, 1, nil, 0, 0, S_FRANK_TPOSE}
states[S_PLAY_FRCHAIR1] = {SPR_PLAY, SPR2_MLEL|FF_ANIMATE, 27, nil, 9, 3, S_PLAY_FRCHAIR2}
states[S_PLAY_FRCHAIR2] = {SPR_PLAY, SPR2_FIRE, 1, nil, 0, 0, S_PLAY_FRCHAIR2}
states[S_PLAY_2POINT1] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_PLAY_2POINT1}
states[S_PLAY_BANANA] = {SPR_PLAY, SPR2_TAL2, 4, nil, 0, 0, S_PLAY_BANANA}

COM_AddCommand("frankdance", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "chaos"
			player.dancesel = 1
			CONS_Printf(player, "Dance selected: Chaos")
		end
		if arg == "spin"
			player.dancesel = 2
			CONS_Printf(player, "Dance selected: Spin")
		end		
		if arg == "nath"
			player.dancesel = 5
			CONS_Printf(player, "Dance selected: Nobody's Around To Help")
		end
		if arg == "club"
			player.dancesel = 3
			CONS_Printf(player, "Dance selected: Club Penguin")
		end
		if arg == "hdance"
			player.dancesel = 4
			CONS_Printf(player, "Dance selected: H Dance")
		end
		if arg == "spooky"
			player.dancesel = 6
			CONS_Printf(player, "Dance selected: Spooky Month")
		end
		if arg == "tpose" //cheater >:(
			player.dancesel = 7
			CONS_Printf(player, "\x83SECRET\x80 Dance selected: T Pose")
		end
		if arg == "favchair" //cheater >:(
			player.dancesel = 8
			CONS_Printf(player, "\x83SECRET\x80 Dance selected: Swag Chair")
		end
		if arg == "didyougetallthosechaosemeralds" //cheater >:(
			player.dancesel = 9
			CONS_Printf(player, "\x83SECRET\x80 Dance selected: Did you get all those chaos emeralds?")
		end
		if arg == "random"
			player.dancesel = 0
			CONS_Printf(player, "Dance selected: Random [Default Option]")	
		end
		if arg == "banana"
			player.dancesel = 10
			CONS_Printf(player, "Dance selected: Peanut Butter Jelly Time")
		end
	else
		CONS_Printf(player,"frankdance <dance> - Use this to select a dance Frank will do all the time. [chaos/spin/nath/club/hdance/spooky/banana/random]")
	end
end)


addHook("PlayerSpawn", function(player)
	player.frankgroovin = false
	P_RestoreMusic(player)
	player.pflags = $1 & ~PF_FULLSTASIS
	if player.mo and player.mo.valid
	and (player.mo.state == S_PLAY_FRCHAIR1 or player.mo.state == S_PLAY_FRCHAIR2 or player.mo.state == S_PLAY_CLUBPENG2 or player.mo.state == S_FRANK_TPOSE or player.mo.state == S_PLAY_JEVIL or player.mo.state == S_PLAY_DSPIN or player.mo.state == S_PLAY_CLUBPENG or player.mo.state == S_PLAY_HDANCE or player.mo.state == S_PLAY_DHELP or player.mo.state == S_PLAY_SPOOKDANCE)
		player.mo.state = S_PLAY_STND
	end
	if player.mo and player.mo.valid and player.mo.skin == "frank"	
		if player.powers[pw_carry] != CR_NIGHTSMODE then player.mo.state = S_PLAY_STND end
	end
end)

addHook("ShouldJingleContinue", function(player, musname)
	if true return end
	if musname != "FRPBNJ" or musname != "_RECAT" or musname != "FRSPOK" or musname != "FRICE" or musname != "FRTWR" or musname != "FRNATH" or musname != "FRSPIN" or musname != "FRHDNC" return end
	if player and player.mo and player.mo.skin == "frank" and player.frankgroovin
		return true
	else
		return false
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.state == S_PLAY_FACEPLANT return end //cant dance when dead idot >:(
	if player.dancetoggle == 0 return end //aw man :(
	if (player.boat and player.boat.valid) return end
	if player.mo and player.mo.valid and (player.mo.milnejoin and player.mo.milnejoin.valid) and player.dancetoggle == 3 return end //kicking quickfix
	
	if (gamemap != 1) and srb2p
		if server.P_BattleStatus and server.P_BattleStatus[player.P_party].running return end
	end


	if player.sfxtoggler == nil
		player.sfxtoggler = true 
		player.dancesel = 0
	end

	if player.mo and player.mo.valid and player.mo.skin == "frank"	
		
		if not player.frankgroovin
			player.startrandom = 0
			player.startdncsong = 0
			player.frstartdnc = 0
			player.frdncesfx = 0
			player.clubpart = 0
		end
		//Detect when we press the key
		if not ((player.cmd.buttons & BT_TOSSFLAG and player.dancetoggle == 1) or (player.cmd.buttons & BT_CUSTOM1 and player.dancetoggle == 2) or (player.cmd.buttons & BT_CUSTOM3 and player.dancetoggle == 3))
			player.canflagpushfrank = true
			player.flagpushfrank = false
		elseif player.canflagpushfrank 
			player.flagpushfrank = true
			player.canflagpushfrank = false
		else
			player.flagpushfrank = false
		end
		if G_IsSpecialStage()
		or player.panim == PA_PAIN
		or player.panim == PA_DEAD
		or player.mo.state == S_PLAY_DEAD
			player.canflagpushfrank = false
			player.flagpushfrank = false
		end
		
		if player.frankgroovin
			if (player.mo.state != S_PLAY_2POINT1 or player.mo.state != S_PLAY_FRCHAIR1 or player.mo.state != S_PLAY_FRCHAIR2 or player.mo.state != S_PLAY_CLUBPENG2 or player.mo.state != S_FRANK_TPOSE or player.mo.state != S_PLAY_JEVIL or player.mo.state != S_PLAY_DSPIN or player.mo.state != S_PLAY_CLUBPENG or player.mo.state != S_PLAY_HDANCE or player.mo.state != S_PLAY_DHELP or player.mo.state != S_PLAY_SPOOKDANCE)
			and (player.mo.eflags & MFE_SPRUNG or player.mo.state == S_PLAY_STND)
				if player.randdance == 1
				or player.dancesel == 1
					player.mo.state = S_PLAY_JEVIL
				elseif player.randdance == 2
				or player.dancesel == 2
					player.mo.state = S_PLAY_DSPIN
				elseif player.randdance == 3 and player.clubpart == 0
				or player.dancesel == 3 and player.clubpart == 0
					player.mo.state = S_PLAY_CLUBPENG
					player.clubpart = 1
				elseif player.randdance == 4
				or player.dancesel == 4
					player.mo.state = S_PLAY_HDANCE
				elseif player.randdance == 5
				or player.dancesel == 5
					player.mo.state = S_PLAY_DHELP
				elseif player.randdance == 6
				or player.dancesel == 6
					player.mo.state = S_PLAY_SPOOKDANCE
				elseif player.dancesel == 7
					player.mo.state = S_FRANK_TPOSE
				elseif player.dancesel == 8
					player.mo.state = S_PLAY_FRCHAIR1
				elseif player.dancesel == 9
					player.mo.state = S_PLAY_2POINT1
				elseif player.randdance == 7
				or player.dancesel == 10
					player.mo.state = S_PLAY_BANANA
				end
				
			end
		
			if not (P_IsObjectOnGround(player.mo))
			or player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPINDASH
			or player.flagpushfrank
				if (player.mo.state == S_PLAY_BANANA or player.mo.state == S_PLAY_2POINT1 or player.mo.state == S_PLAY_FRCHAIR1 or player.mo.state == S_PLAY_FRCHAIR2 or player.mo.state == S_PLAY_CLUBPENG2 or player.mo.state == S_FRANK_TPOSE or player.mo.state == S_PLAY_JEVIL or player.mo.state == S_PLAY_DSPIN or player.mo.state == S_PLAY_CLUBPENG or player.mo.state == S_PLAY_HDANCE or player.mo.state == S_PLAY_DHELP or player.mo.state == S_PLAY_SPOOKDANCE)
					if player.playerstate != PST_LIVE
						player.mo.state = S_PLAY_DEAD
					else
						player.mo.state = S_PLAY_STND
					end
				end
				player.frankgroovin = false
				if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
				and not (player.powers[pw_sneakers] and not player.powers[pw_super])		
					P_RestoreMusic(player)
				end
			else
				if (player.mo.state != S_PLAY_BANANA or player.mo.state != S_PLAY_2POINT1 or player.mo.state != S_PLAY_FRCHAIR1 or player.mo.state != S_PLAY_FRCHAIR2 or player.mo.state != S_PLAY_CLUBPENG2 or player.mo.state != S_FRANK_TPOSE or player.mo.state != S_PLAY_JEVIL or player.mo.state != S_PLAY_DSPIN or player.mo.state != S_PLAY_CLUBPENG or player.mo.state != S_PLAY_HDANCE or player.mo.state != S_PLAY_DHELP or player.mo.state != S_PLAY_SPOOKDANCE)
					player.pflags = $|PF_FULLSTASIS
					//RANDOMIZER
					if player.startrandom == 0
					and player.dancesel == 0
						player.randdance = P_RandomRange(1, 7)
						player.startrandom = 1
					end
					if player.dancesel != 0
						player.randdance = 0
					end
					//the animation
					if player.frstartdnc == 0
						if player.randdance == 1
						or player.dancesel == 1
							player.mo.state = S_PLAY_JEVIL
						elseif player.randdance == 2
						or player.dancesel == 2
							player.mo.state = S_PLAY_DSPIN
						elseif player.randdance == 3
						or player.dancesel == 3
							player.mo.state = S_PLAY_CLUBPENG
						elseif player.randdance == 4
						or player.dancesel == 4
							player.mo.state = S_PLAY_HDANCE
						elseif player.randdance == 5
						or player.dancesel == 5
							player.mo.state = S_PLAY_DHELP
						elseif player.randdance == 6
						or player.dancesel == 6
							player.mo.state = S_PLAY_SPOOKDANCE
						elseif player.dancesel == 7
							player.mo.state = S_FRANK_TPOSE
						elseif player.dancesel == 8
							player.mo.state = S_PLAY_FRCHAIR1
						elseif player.dancesel == 9
							player.mo.state = S_PLAY_2POINT1
						elseif player.randdance == 7
						or player.dancesel == 10
							player.mo.state = S_PLAY_BANANA
						end
						player.frstartdnc = 1
					end
					
					//sfx (with a special toggle feature)
					if player.frdncesfx == 0
					and player.sfxtoggler == true 
						if player.mo.state == S_PLAY_JEVIL
							S_StartSound(player.mo, sfx_frlaf1)
						elseif player.mo.state == S_PLAY_DSPIN
							S_StartSound(player.mo, sfx_frspn1)
						elseif player.mo.state == S_PLAY_CLUBPENG
						or player.mo.state == S_PLAY_FRCHAIR1
							S_StartSound(player.mo, sfx_frstmp)
						elseif player.mo.state == S_PLAY_HDANCE
						or player.mo.state == S_FRANK_TPOSE
							S_StartSound(player.mo, sfx_frhorn)
						elseif player.mo.state == S_PLAY_DHELP
							S_StartSound(player.mo, sfx_frac)
						elseif player.mo.state == S_PLAY_SPOOKDANCE
							S_StartSound(player.mo, sfx_frspok)
						elseif player.mo.state == S_PLAY_2POINT1
							S_StartSound(player.mo, sfx_thok)
						elseif player.mo.state == S_PLAY_BANANA
							S_StartSound(player.mo, sfx_frpbnj)
						end
						
						
						local dancenote = P_SpawnMobjFromMobj(player.mo, 0,0,2*FRACUNIT, MT_FADNOTE)
						dancenote.color = ColorOpposite(player.mo.color)
						P_SetObjectMomZ(dancenote, 8*FRACUNIT, false)
						dancenote.angle = FixedAngle(P_RandomRange(0,359)*FRACUNIT)
						P_Thrust(dancenote, dancenote.angle, 4*FRACUNIT)
						dancenote.colorized = true
						dancenote.destscale = $/10
						dancenote.scalespeed = FRACUNIT/12
						player.frdncesfx = 1
					end
					
					//music (cant play when inv. or super/hyper)
					if player.startdncsong == 0
					and not (player.powers[pw_invulnerability] and not player.powers[pw_super])
					and not (player.powers[pw_sneakers] and not player.powers[pw_super])
						if player.mo.state == S_PLAY_JEVIL
							P_PlayJingleMusic(player, "FRTWR", nil, true, JT_OTHER)		
						elseif player.mo.state == S_PLAY_DSPIN
							P_PlayJingleMusic(player, "FRSPIN", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_CLUBPENG
							P_PlayJingleMusic(player, "FRICE", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_HDANCE
							P_PlayJingleMusic(player, "FRHDNC", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_DHELP
						or player.mo.state == S_PLAY_FRCHAIR1
							P_PlayJingleMusic(player, "FRNATH", nil, true, JT_OTHER)
						elseif player.mo.state == S_PLAY_SPOOKDANCE
							P_PlayJingleMusic(player, "FRSPOK", nil, true, JT_OTHER)
						elseif player.mo.state == S_FRANK_TPOSE
							if srb2p
								P_PlayJingleMusic(player, "FRHDNC", nil, true, JT_OTHER)
							else
								P_PlayJingleMusic(player, "_RECAT", nil, true, JT_OTHER)
							end
						elseif player.mo.state == S_PLAY_2POINT1
							if srb2p
								P_PlayJingleMusic(player, "FRICE", nil, true, JT_OTHER)
							else
								P_PlayJingleMusic(player, "VSALT", nil, true, JT_OTHER)
							end
						elseif player.mo.state == S_PLAY_BANANA
							P_PlayJingleMusic(player, "FRPBNJ", nil, true, JT_OTHER)
						end
						player.startdncsong = 1
					end
				end
			end
			if player.powers[pw_carry] == CR_MACESPIN
			or (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
				player.mo.state = S_PLAY_ROLL
				player.frankgroovin = false
				if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
				and not (player.powers[pw_sneakers] and not player.powers[pw_super])
					P_RestoreMusic(player)
				end
			end
		elseif P_IsObjectOnGround(player.mo)
		and player.mo.state != S_PLAY_ROLL and not player.mo.state != S_PLAY_SPINDASH
		and player.flagpushfrank
			player.frankgroovin = true
		end
	else
		if player.frankgroovin
			if (player.mo.state == S_PLAY_BANANA or player.mo.state == S_PLAY_2POINT1 or player.mo.state == S_PLAY_FRCHAIR1 or player.mo.state == S_PLAY_FRCHAIR2 or player.mo.state == S_PLAY_CLUBPENG2 or player.mo.state == S_FRANK_TPOSE or player.mo.state == S_PLAY_JEVIL or player.mo.state == S_PLAY_DSPIN or player.mo.state == S_PLAY_CLUBPENG or player.mo.state == S_PLAY_HDANCE or player.mo.state == S_PLAY_DHELP or player.mo.state == S_PLAY_SPOOKDANCE)
				player.mo.state = S_PLAY_STND
			end
			player.frankgroovin = false
			if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
			and not (player.powers[pw_sneakers] and not player.powers[pw_super])
				P_RestoreMusic(player)
			end
		end
	end
end)