freeslot("S_PLAY_GROOVE", "S_D_2POINT1", "S_PLAY_HOME")
states[S_PLAY_GROOVE] = {SPR_PLAY, SPR2_CLMB, 3, nil, 0, 0, S_PLAY_GROOVE}
states[S_PLAY_HOME] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_PLAY_HOME}
states[S_D_2POINT1] = {SPR_PLAY, SPR2_TWIN, 1, nil, 0, 0, S_D_2POINT1}

addHook("PlayerThink", function(player)
	if player.stuckathome == nil
		player.stuckathome = false
	end
end)

addHook("PlayerSpawn", function(player)
	player.dummiegroovin = false
	P_RestoreMusic(player)
	player.pflags = $1 & ~PF_FULLSTASIS
	if player.mo and player.mo.valid
	and (player.mo.state == S_PLAY_GROOVE or player.mo.state == S_PLAY_HOME)
		player.mo.state = S_PLAY_STND
	end
	if player.mo and player.mo.valid and player.mo.skin == "dummie"	
		if player.powers[pw_carry] != CR_NIGHTSMODE then player.mo.state = S_PLAY_STND end
	end
end)

addHook("ShouldJingleContinue", function(player, musname)
	if true return end
	if musname != "DUMDNC" or musname != "SHWTME" return end
	if player and player.mo and player.mo.skin == "dummie" and player.dummiegroovin
		return true
	else
		return false
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.state == S_PLAY_FACEPLANT return end //cant dance when dead idot >:(
	if player.dancetoggle == 0 return end //aw man :(
	if (player.boat and player.boat.valid) return end
	if player.mo and player.mo.valid and (player.mo.milnejoin and player.mo.milnejoin.valid) and player.dancetoggle == 3 return end //kicking quickfix
	
	if (gamemap != 1) and srb2p
		if server.P_BattleStatus and server.P_BattleStatus[player.P_party].running return end
	end
	
	
	if player.mo and player.mo.valid and player.mo.skin == "dummie"	
		if player.powers[pw_carry] then 
			player.dummiegroovin = false 
			if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
			and not (player.powers[pw_sneakers] and not player.powers[pw_super])
				P_RestoreMusic(player)
			end
			return
		end
		
		//Detect when we press the key
		if not ((player.cmd.buttons & BT_TOSSFLAG and player.dancetoggle == 1) or (player.cmd.buttons & BT_CUSTOM1 and player.dancetoggle == 2) or (player.cmd.buttons & BT_CUSTOM3 and player.dancetoggle == 3))
			player.canpushflagdum = true
			player.pushingflagdum = false
		elseif player.canpushflagdum 
			player.pushingflagdum = true
			player.canpushflagdum = false
		else
			player.pushingflagdum = false
		end
		if G_IsSpecialStage()
		or player.panim == PA_PAIN
		or player.panim == PA_DEAD
		or player.mo.state == S_PLAY_DEAD
			player.canpushflagdum = false
			player.pushingflagdum = false
		end
		if not player.dummiegroovin
			player.dudncesfx = 0
		end
		
		if player.dummiegroovin
			if not (P_IsObjectOnGround(player.mo))
			or player.pushingflagdum
				if player.mo.state == S_PLAY_GROOVE
				or player.mo.state == S_PLAY_HOME
					if player.playerstate != PST_LIVE
						player.mo.state = S_PLAY_DEAD
					else
						player.mo.state = S_PLAY_STND
					end
				end
				player.dummiegroovin = false
				if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
				and not (player.powers[pw_sneakers] and not player.powers[pw_super])
					P_RestoreMusic(player)
				end
			else
				if player.mo.state != S_PLAY_GROOVE
				and player.mo.state != S_D_2POINT1
				and player.mo.state != S_PLAY_HOME
					if player.stuckathome
						player.mo.state = S_PLAY_HOME
					else
						player.mo.state = S_PLAY_GROOVE
					end
					if player.dudncesfx == 0
						S_StartSound(player.mo, sfx_fadwow)
						
						local dancenote = P_SpawnMobjFromMobj(player.mo, 0,0,2*FRACUNIT, MT_FADNOTE)
						dancenote.color = ColorOpposite(player.mo.color)
						P_SetObjectMomZ(dancenote, 8*FRACUNIT, false)
						dancenote.angle = FixedAngle(P_RandomRange(0,359)*FRACUNIT)
						P_Thrust(dancenote, dancenote.angle, 4*FRACUNIT)
						dancenote.colorized = true
						dancenote.destscale = $/10
						dancenote.scalespeed = FRACUNIT/12
						player.dudncesfx = 1
					end
				end
				player.pflags = $|PF_FULLSTASIS
			end
			if player.powers[pw_carry] == CR_MACESPIN
			or (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
				player.mo.state = S_PLAY_ROLL
				player.dummiegroovin = false
				if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
				and not (player.powers[pw_sneakers] and not player.powers[pw_super])
					P_RestoreMusic(player)
				end
			end
			
		elseif P_IsObjectOnGround(player.mo)
		and player.mo.state != S_PLAY_ROLL and not player.mo.state != S_PLAY_SPINDASH and not player.mo.state != S_PLAY_FACEPLANT and not player.mo.state != S_PLAY_2POINT1
		and player.pushingflagdum
		and player.playerstate == PST_LIVE
			player.dummiegroovin = true
			if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
			and not (player.powers[pw_sneakers] and not player.powers[pw_super])
				if player.stuckathome
					P_PlayJingleMusic(player, "SHWTME", nil, true, JT_OTHER)
				else
					P_PlayJingleMusic(player, "DUMDNC", nil, true, JT_OTHER)
				end
			end
		end
	else
		if player.dummiegroovin
			if player.mo.state == S_PLAY_GROOVE
			or player.mo.state == S_PLAY_HOME
				player.mo.state = S_PLAY_STND
			end
			player.dummiegroovin = false
			if not (player.powers[pw_invulnerability] and not player.powers[pw_super])
			and not (player.powers[pw_sneakers] and not player.powers[pw_super])
				P_RestoreMusic(player)
			end
		end
	end
end)

COM_AddCommand("dummiesecret", function(player, arg)
	if arg
		if arg == "storypagenumber405"
			player.stuckathome = true
			CONS_Printf(player, "Wait, what are you doing? Do you even know what you did??? Turn it back off!")
		elseif arg == "0" or arg == "false" or arg == "off"
		and player.stuckathome
			player.stuckathome = false
			CONS_Printf(player, "Phew.. That's better.")
		end
	end
end)